//页面统一入口
var rootBackPress = false;
var _close;
apiready = function() {


    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        var name = api.winName;
        if (name != "root" && name != "index") {
            if (_close) {
                _close();
            }
            api.closeWin();
        } else {
            if (rootBackPress == false) // 如果没有按过
            {
                rootBackPress = true;
                showToast("再按一次关闭程序", function() {
                    rootBackPress = false;
                });
            } else {
                api.closeWidget({
                    id: api.appId,
                    retData: {
                        name: 'closeWidget'
                    },
                    silent: true
                });
            }
        }
    });

    // var header = $api.dom('header');
    // var isFix = header.getAttribute("isFix");
    // if (isFix == null || isFix == "true") {
    //     $api.fixStatusBar(header);
    // }
    if (_apiready) {
        _apiready();
        api.setStatusBarStyle({
            style: 'light',
            color: '#1788ee'
        });
        if ($api.dom('header')) {
            var body = $api.dom('body');
            var notfix = body.getAttribute("notfix");
            if (notfix == "true") {} else {
                $api.fixStatusBar($api.dom('header'));
            }
        }
    }

    var back = $api.dom(".aui-icon-left");
    if (back) {
        $api.addEvt(back, 'click', function() {
            if (_close) {
                _close();
            }
            api.closeWin();
        });
    }
};


var showLoading = function(msg) {
    msg = msg || "加载中";
    api.showProgress({
        style: 'default',
        animationType: 'fade',
        title: '',
        text: msg,
        modal: true
    });

};
var closeLoading = function() {
    api.hideProgress();
};

/**
 * 发一个自动隐藏的消息
 * @param  {[type]} msg 消息
 * @param  {[type]} end 结束回调
 * @param  {[type]} t   时间-ms
 * @return {[type]}
 */
var showToast = function(msg, end, t) {
    var times = t || 2000;
    api.toast({
        msg: msg,
        duration: times,
        location: 'middle'
    });
    if (end) {
        setTimeout(function() {
            end();
        }, times);
    }
};

String.prototype.CheckRegexp = function(regexp) {
    var re = new RegExp(regexp);
    if (re.test(this)) {
        return true;
    } else {
        return false;
    }
}

String.prototype.isEmpty = function() {
    if (this == undefined) {
        return true;
    }
    if (this.replace(/(^s*)|(s*$)/g, "").length == 0) {
        return true;
    }
    return false;
};



String.prototype.verifyReg = function(reg) {
    if (this.length != 0) {
        var r = this.match(reg);
        if (r == null) {
            return false;
        } else {
            return true;
        }
    }
    return false;
}


function setUserInfo(userInfo) {
    var data = $api.jsonToStr(userInfo);
    data = data.Encrypt(); //加密
    $api.setStorage('$userInfo', data);
};


/**
 * 获取用户信息
 * @return {userInfo}
 */
function getUserInfo() {
    var _data = $api.getStorage('$userInfo');
    if (_data) {
        _data = _data.Decrypt(); //解密
        return $api.strToJson(_data);
    }
    return null;
}


function setQrcode(qrcode) {
    var data = $api.jsonToStr(qrcode);
    alert(data);
    data = data.Encrypt(); //加密
    $api.setStorage('$qrcode', data);
};


/**
 * 获取用户信息
 * @return {userInfo}
 */
function getQurcode() {
    var _data = $api.getStorage('$qrcode');
    if (_data) {
        _data = _data.Decrypt(); //解密
        return $api.strToJson(_data);
    }
    return null;
}



function setToken(authInfo) {
    var data = $api.jsonToStr(authInfo);
    data = data.Encrypt(); //加密
    $api.setStorage('$token', data);
}

function getToken() {
    var _data = $api.getStorage('$token');
    if (_data) {
        _data = _data.Decrypt(); //解密
        return $api.strToJson(_data);
    }
    return null;
}
/**
 * 清除登录状态
 */
function clearLoginStatus() {
    $api.rmStorage('$token');
    $api.rmStorage('$userInfo');
}


function checkLogin(end) {
    if (getToken()) {
        end();
    } else {
        api.sendEvent({
            name: 'goLogin'
        });
    }
}

function showSelect(datas, end, act) {
    var UIActionSelector = api.require("UIActionSelector");
    var opt = {
        datas: datas,
        layout: {
            row: 5,
            col: 3,
            height: 30,
            size: 12,
            sizeActive: 14,
            rowSpacing: 5,
            colSpacing: 10,
            maskBg: 'rgba(0,0,0,0.2)',
            bg: '#fff',
            color: '#888',
            colorActive: '#f00',
            colorSelected: '#f00'
        },
        animation: true,
        cancel: {
            text: '取消',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
        },
        ok: {
            text: '确定',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
        },
        title: {
            text: '请选择',
            size: 12,
            h: 44,
            bg: '#eee',
            color: '#888'
        },
        fixedOn: api.frameName
    };
    if (act) {
        opt.actives = act;
    }
    UIActionSelector.open(opt, function(ret, err) {
        if (ret) {
            if (ret.eventType == "ok") {
                end(ret);
            }
        } else {}
    });

}

var regCheck = function(str, reg) {
    if (!reg.test(str)) {
        return false;
    } else {
        return true;
    }
}

function showConfirm(msg, opt) {
    if (api) {

        var cancelButton = opt.cancelButton || "取消";
        var okButton = opt.okButton || "确认";
        var dialog = api.require("dialogBox");
        var ok = opt.ok || function() {};
        var cancle = opt.cancle || function() {};

        api.confirm({
            title: '确认',
            msg: msg,
            buttons: [okButton, cancelButton]
        }, function(ret, err) {
            if (ret) {
                if (ret.buttonIndex == 1) {
                    ok();
                } else {
                    cancle();
                }
            } else {

            }
        });

    } else {
        alert("请先调用ApiReady函数等待Api初始化后再调用此函数");
    }
}
