//这里到时候配置到key.xml文件内去
var ServicesUrl = "http://app.yunhpay.com/"; //生产地址
//var ServicesUrl = "http://test.yunhpay.com:8080/";
//这里配置所有系统的所用到的地址，在以后修改的时候方便使用
var ConstUrl = {
    Login: ServicesUrl + "FHMYSQL/login_checkLogin",
    QueryUserInfo: ServicesUrl + "FHMYSQL/pay/getUserInfoByRedis",
    FindPwdMsg: ServicesUrl + "FHMYSQL/pay/findVerCode",
    Receivables: ServicesUrl + "FHMYSQL/pay/subMicroPay",
    SavePwd: ServicesUrl + "FHMYSQL/pay/checkMesCode",
    QueryTodayReport: ServicesUrl + "FHMYSQL/app/getTodayData",
    QueryBillList: ServicesUrl + "FHMYSQL/app/billsList",
    QueryDayReport: ServicesUrl + "FHMYSQL/app/dayReport",
    QueryMonthReport: ServicesUrl + "FHMYSQL/app/monthReport",
    QueryQrCode: ServicesUrl + "FHMYSQL/app/getQrcode",
    ChangeBoBaoSet: ServicesUrl + "FHMYSQL/pay/changeIsBroadcast",
    QueryShops: ServicesUrl + "FHMYSQL/pay/queryCompanyShopName",
    QueryCashier: ServicesUrl + "FHMYSQL/pay/queryCompanyShopCashierName",
    BindQrcode: ServicesUrl + "FHMYSQL/app/bindCode",
    EditLoginPassword: ServicesUrl + "FHMYSQL/pay/changePwd",
    EditOperationPassword: ServicesUrl + "FHMYSQL/pay/changeCompanySet",
    EditOrderRefund: ServicesUrl + "FHMYSQL/pay/refundment",
    QueryOrderDetails: ServicesUrl + "FHMYSQL/app/orderDetails",
    QueryOrderSummary: ServicesUrl + "FHMYSQL/app/orderReport",
    EditCompanyInfo: ServicesUrl + "FHMYSQL/pay/changeCompanyInfo",
    EditDailyInfo: ServicesUrl + "FHMYSQL/pay/changeDailyInfo",
    EditMerchantLogo: ServicesUrl + "FHMYSQL/appuser/uploadShLogo",
    EditShopLogo: ServicesUrl + "FHMYSQL/appuser/uploadDpLogo",
    SearchOrder: ServicesUrl + "FHMYSQL/appuser/searchByOrderNoLike"

};

var isDebug = false;

/**************************************************************
 *字符串加密
 *   str：需要加密的字符串
 ****************************************************************/
String.prototype.Encrypt = function(str) {
    var aesKey = api.loadSecureValue({
        sync: true,
        key: 'aesKey'
    });
    var aesIv = api.loadSecureValue({
        sync: true,
        key: 'aesIv'
    });

    var str = this.toString();
    var key = CryptoJS.enc.Utf8.parse(aesKey);
    var iv = CryptoJS.enc.Utf8.parse(aesIv);

    var encrypted = '';

    var srcs = CryptoJS.enc.Utf8.parse(str);
    encrypted = CryptoJS.AES.encrypt(srcs, key, {
        iv: iv,
        mode: CryptoJS.mode.CBC,
        padding: CryptoJS.pad.Pkcs7
    });

    return encrypted.ciphertext.toString();
};
/**************************************************************
 *字符串解密
 *   str：需要解密的字符串
 ****************************************************************/
String.prototype.Decrypt = function() {

    var aesKey = api.loadSecureValue({
        sync: true,
        key: 'aesKey'
    });
    var aesIv = api.loadSecureValue({
        sync: true,
        key: 'aesIv'
    });

    var str = this.toString();
    var key = CryptoJS.enc.Utf8.parse(aesKey);
    var iv = CryptoJS.enc.Utf8.parse(aesIv);
    var encryptedHexStr = CryptoJS.enc.Hex.parse(str);
    var srcs = CryptoJS.enc.Base64.stringify(encryptedHexStr);
    var decrypt = CryptoJS.AES.decrypt(srcs, key, {
        iv: iv,
        mode: CryptoJS.mode.CBC,
        padding: CryptoJS.pad.Pkcs7
    });
    var decryptedStr = decrypt.toString(CryptoJS.enc.Utf8);
    return decryptedStr.toString();
}

var updateFile = function(url, opt, file) {
    sendAjax(url, {
        isDecode: opt.isDecode,
        isParamDecode: opt.isParamDecode,
        param: opt.param,
        method: "get",
        report: opt.report
    }, opt.success, opt.error, opt.finish, file);
}

var sendAjax = function(url, opt, success, error, finish, file) {
    var isDecode = opt.isDecode == undefined ? true : opt.isDecode;
    var isParamDecode = opt.isParamDecode == undefined ? true : opt.isParamDecode;
    var method = opt.method || "get";
    opt.param = opt.param || {};
    finish = finish || function() {
        closeLoading();
    };

    var auth = getToken();
    if (auth) {
        opt.param.token = auth.token;
    }
    var paramStr = $api.jsonToStr(opt.param || {});
    if (isParamDecode) {
        paramStr = paramStr.Encrypt();
    }

    var ajaxOpt = {
        method: method,
        timeout: 10,
        cache: opt.cache
    };
    //如果是Post请求
    if (method == "post") {
        ajaxOpt.data = {
            values: {
                jsonString: paramStr
            }
        };
    } else {
        url = url + "?jsonString=" + paramStr;
        if (file) {
            ajaxOpt.data = {
                files: {
                    "file": file
                }
            };
            ajaxOpt.data.report = opt.report;
        }
    }
    ajaxOpt.url = url;
    api.ajax(ajaxOpt, function(ret, err) {
        if (err) {
            if (err.statusCode == 200) {
                ret = err.body;
            }
        }

        console.log("参数:" + $api.jsonToStr(opt.param || {}));
        if (isDebug) {
            console.log("请求:" + ajaxOpt.url);
            var types = typeof(ret).toString();
            if (types == "string") {
                console.log("返回:" + $api.jsonToStr(err));
            }
        }
        try {

            checkRequest(ret, err, success, error, isDecode);
        } catch (e) {
            console.log(e);
        } finally {
            if (finish) {
                finish();
            }
        }

    });
};

/**
 * 发送一个Post请求
 * @param  {ServicesConifg} url     请求地址
 * @param  {Object} param   参数，{a:"a",b:"b"}
 * @param  {Func} success 成功回调方法
 * @param  {Func} error   错误回调方法
 * @return {}         没有返回数据
 */
var sendPost = function(url, param, opt) {

    sendAjax(url, {
        isDecode: opt.isDecode,
        isParamDecode: opt.isParamDecode,
        param: param,
        method: "post"
    }, opt.success, opt.error, opt.finish);
};


var sendGet = function(url, opt) {
    sendAjax(url, {
        isDecode: opt.isDecode,
        isParamDecode: opt.isParamDecode,
        method: "get",
        param: opt.param,
        cache: opt.cache || false
    }, opt.success, opt.error, opt.finish);
};




/**
 * 回调统一处理
 * @param  {[type]}  succ     [description]
 * @param  {[type]}  success  [description]
 * @param  {[type]}  error    [description]
 * @param  {Boolean} isDecode [description]
 * @return {[type]}           [description]
 */
var checkRequest = function(succ, err, success, error, isDecode) {
    isDecode = isDecode || false;
    error = error || function(msg) {
        showToast(msg);
    };
    if (succ) {
        var jData = {};
        try {
            var types = typeof(succ);
            if (types == "string") {
                succ = succ.Decrypt();
                console.log(succ);
                jData = JSON.parse(succ)
            } else {
                jData = succ;
            }
        } catch (e) {
            error("数据格式错误");
            console.log(e);
        }
        if (jData.err == "0") {
            var output = jData.output || {};
            if (success) {
                success(jData, output);
            }
        } else {
            if (jData.msg)
                error(jData.msg);
        }
    } else {
        if (err) {
            if (err.statusCode == 500) {
                error("服务器通信错误");
                console.log(err.body);
            } else {
                error(err.msg);
            }
        } else {
            error("未知错误");
        }
    }
}
